
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "applikation",
    "aufrufParameter",
    "inkarnationsTyp",
    "inkarnationsName",
    "initialize",
    "mitInkarnationsName",
    "startArt",
    "startBedingung",
    "startFehlerVerhalten",
    "stoppBedingung",
    "stoppFehlerVerhalten"
})
public class Inkarnation implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("applikation")
    private String applikation;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aufrufParameter")
    private List<String> aufrufParameter = new ArrayList<String>();
    @JsonProperty("inkarnationsTyp")
    private Inkarnation.InkarnationsTyp inkarnationsTyp = Inkarnation.InkarnationsTyp.fromValue("dav");
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    private String inkarnationsName;
    @JsonProperty("initialize")
    private Boolean initialize = false;
    @JsonProperty("mitInkarnationsName")
    private Boolean mitInkarnationsName = true;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startArt")
    private StartArt startArt;
    @JsonProperty("startBedingung")
    private StartBedingung startBedingung;
    @JsonProperty("startFehlerVerhalten")
    private StartFehlerVerhalten startFehlerVerhalten;
    @JsonProperty("stoppBedingung")
    private StoppBedingung stoppBedingung;
    @JsonProperty("stoppFehlerVerhalten")
    private StoppFehlerVerhalten stoppFehlerVerhalten;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -122992741555406910L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Inkarnation() {
    }

    /**
     * 
     * @param inkarnationsTyp
     * @param applikation
     * @param aufrufParameter
     * @param stoppBedingung
     * @param inkarnationsName
     * @param startFehlerVerhalten
     * @param initialize
     * @param startArt
     * @param mitInkarnationsName
     * @param startBedingung
     * @param stoppFehlerVerhalten
     */
    public Inkarnation(String applikation, List<String> aufrufParameter, Inkarnation.InkarnationsTyp inkarnationsTyp, String inkarnationsName, Boolean initialize, Boolean mitInkarnationsName, StartArt startArt, StartBedingung startBedingung, StartFehlerVerhalten startFehlerVerhalten, StoppBedingung stoppBedingung, StoppFehlerVerhalten stoppFehlerVerhalten) {
        super();
        this.applikation = applikation;
        this.aufrufParameter = aufrufParameter;
        this.inkarnationsTyp = inkarnationsTyp;
        this.inkarnationsName = inkarnationsName;
        this.initialize = initialize;
        this.mitInkarnationsName = mitInkarnationsName;
        this.startArt = startArt;
        this.startBedingung = startBedingung;
        this.startFehlerVerhalten = startFehlerVerhalten;
        this.stoppBedingung = stoppBedingung;
        this.stoppFehlerVerhalten = stoppFehlerVerhalten;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("applikation")
    public String getApplikation() {
        return applikation;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("applikation")
    public void setApplikation(String applikation) {
        this.applikation = applikation;
    }

    public Inkarnation withApplikation(String applikation) {
        this.applikation = applikation;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aufrufParameter")
    public List<String> getAufrufParameter() {
        return aufrufParameter;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aufrufParameter")
    public void setAufrufParameter(List<String> aufrufParameter) {
        this.aufrufParameter = aufrufParameter;
    }

    public Inkarnation withAufrufParameter(List<String> aufrufParameter) {
        this.aufrufParameter = aufrufParameter;
        return this;
    }

    @JsonProperty("inkarnationsTyp")
    public Inkarnation.InkarnationsTyp getInkarnationsTyp() {
        return inkarnationsTyp;
    }

    @JsonProperty("inkarnationsTyp")
    public void setInkarnationsTyp(Inkarnation.InkarnationsTyp inkarnationsTyp) {
        this.inkarnationsTyp = inkarnationsTyp;
    }

    public Inkarnation withInkarnationsTyp(Inkarnation.InkarnationsTyp inkarnationsTyp) {
        this.inkarnationsTyp = inkarnationsTyp;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public String getInkarnationsName() {
        return inkarnationsName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public void setInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
    }

    public Inkarnation withInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
        return this;
    }

    @JsonProperty("initialize")
    public Boolean getInitialize() {
        return initialize;
    }

    @JsonProperty("initialize")
    public void setInitialize(Boolean initialize) {
        this.initialize = initialize;
    }

    public Inkarnation withInitialize(Boolean initialize) {
        this.initialize = initialize;
        return this;
    }

    @JsonProperty("mitInkarnationsName")
    public Boolean getMitInkarnationsName() {
        return mitInkarnationsName;
    }

    @JsonProperty("mitInkarnationsName")
    public void setMitInkarnationsName(Boolean mitInkarnationsName) {
        this.mitInkarnationsName = mitInkarnationsName;
    }

    public Inkarnation withMitInkarnationsName(Boolean mitInkarnationsName) {
        this.mitInkarnationsName = mitInkarnationsName;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startArt")
    public StartArt getStartArt() {
        return startArt;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startArt")
    public void setStartArt(StartArt startArt) {
        this.startArt = startArt;
    }

    public Inkarnation withStartArt(StartArt startArt) {
        this.startArt = startArt;
        return this;
    }

    @JsonProperty("startBedingung")
    public StartBedingung getStartBedingung() {
        return startBedingung;
    }

    @JsonProperty("startBedingung")
    public void setStartBedingung(StartBedingung startBedingung) {
        this.startBedingung = startBedingung;
    }

    public Inkarnation withStartBedingung(StartBedingung startBedingung) {
        this.startBedingung = startBedingung;
        return this;
    }

    @JsonProperty("startFehlerVerhalten")
    public StartFehlerVerhalten getStartFehlerVerhalten() {
        return startFehlerVerhalten;
    }

    @JsonProperty("startFehlerVerhalten")
    public void setStartFehlerVerhalten(StartFehlerVerhalten startFehlerVerhalten) {
        this.startFehlerVerhalten = startFehlerVerhalten;
    }

    public Inkarnation withStartFehlerVerhalten(StartFehlerVerhalten startFehlerVerhalten) {
        this.startFehlerVerhalten = startFehlerVerhalten;
        return this;
    }

    @JsonProperty("stoppBedingung")
    public StoppBedingung getStoppBedingung() {
        return stoppBedingung;
    }

    @JsonProperty("stoppBedingung")
    public void setStoppBedingung(StoppBedingung stoppBedingung) {
        this.stoppBedingung = stoppBedingung;
    }

    public Inkarnation withStoppBedingung(StoppBedingung stoppBedingung) {
        this.stoppBedingung = stoppBedingung;
        return this;
    }

    @JsonProperty("stoppFehlerVerhalten")
    public StoppFehlerVerhalten getStoppFehlerVerhalten() {
        return stoppFehlerVerhalten;
    }

    @JsonProperty("stoppFehlerVerhalten")
    public void setStoppFehlerVerhalten(StoppFehlerVerhalten stoppFehlerVerhalten) {
        this.stoppFehlerVerhalten = stoppFehlerVerhalten;
    }

    public Inkarnation withStoppFehlerVerhalten(StoppFehlerVerhalten stoppFehlerVerhalten) {
        this.stoppFehlerVerhalten = stoppFehlerVerhalten;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Inkarnation withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(Inkarnation.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("applikation");
        sb.append('=');
        sb.append(((this.applikation == null)?"<null>":this.applikation));
        sb.append(',');
        sb.append("aufrufParameter");
        sb.append('=');
        sb.append(((this.aufrufParameter == null)?"<null>":this.aufrufParameter));
        sb.append(',');
        sb.append("inkarnationsTyp");
        sb.append('=');
        sb.append(((this.inkarnationsTyp == null)?"<null>":this.inkarnationsTyp));
        sb.append(',');
        sb.append("inkarnationsName");
        sb.append('=');
        sb.append(((this.inkarnationsName == null)?"<null>":this.inkarnationsName));
        sb.append(',');
        sb.append("initialize");
        sb.append('=');
        sb.append(((this.initialize == null)?"<null>":this.initialize));
        sb.append(',');
        sb.append("mitInkarnationsName");
        sb.append('=');
        sb.append(((this.mitInkarnationsName == null)?"<null>":this.mitInkarnationsName));
        sb.append(',');
        sb.append("startArt");
        sb.append('=');
        sb.append(((this.startArt == null)?"<null>":this.startArt));
        sb.append(',');
        sb.append("startBedingung");
        sb.append('=');
        sb.append(((this.startBedingung == null)?"<null>":this.startBedingung));
        sb.append(',');
        sb.append("startFehlerVerhalten");
        sb.append('=');
        sb.append(((this.startFehlerVerhalten == null)?"<null>":this.startFehlerVerhalten));
        sb.append(',');
        sb.append("stoppBedingung");
        sb.append('=');
        sb.append(((this.stoppBedingung == null)?"<null>":this.stoppBedingung));
        sb.append(',');
        sb.append("stoppFehlerVerhalten");
        sb.append('=');
        sb.append(((this.stoppFehlerVerhalten == null)?"<null>":this.stoppFehlerVerhalten));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.inkarnationsTyp == null)? 0 :this.inkarnationsTyp.hashCode()));
        result = ((result* 31)+((this.applikation == null)? 0 :this.applikation.hashCode()));
        result = ((result* 31)+((this.inkarnationsName == null)? 0 :this.inkarnationsName.hashCode()));
        result = ((result* 31)+((this.startBedingung == null)? 0 :this.startBedingung.hashCode()));
        result = ((result* 31)+((this.stoppFehlerVerhalten == null)? 0 :this.stoppFehlerVerhalten.hashCode()));
        result = ((result* 31)+((this.aufrufParameter == null)? 0 :this.aufrufParameter.hashCode()));
        result = ((result* 31)+((this.stoppBedingung == null)? 0 :this.stoppBedingung.hashCode()));
        result = ((result* 31)+((this.startFehlerVerhalten == null)? 0 :this.startFehlerVerhalten.hashCode()));
        result = ((result* 31)+((this.initialize == null)? 0 :this.initialize.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        result = ((result* 31)+((this.startArt == null)? 0 :this.startArt.hashCode()));
        result = ((result* 31)+((this.mitInkarnationsName == null)? 0 :this.mitInkarnationsName.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Inkarnation) == false) {
            return false;
        }
        Inkarnation rhs = ((Inkarnation) other);
        return (((((((((((((this.inkarnationsTyp == rhs.inkarnationsTyp)||((this.inkarnationsTyp!= null)&&this.inkarnationsTyp.equals(rhs.inkarnationsTyp)))&&((this.applikation == rhs.applikation)||((this.applikation!= null)&&this.applikation.equals(rhs.applikation))))&&((this.inkarnationsName == rhs.inkarnationsName)||((this.inkarnationsName!= null)&&this.inkarnationsName.equals(rhs.inkarnationsName))))&&((this.startBedingung == rhs.startBedingung)||((this.startBedingung!= null)&&this.startBedingung.equals(rhs.startBedingung))))&&((this.stoppFehlerVerhalten == rhs.stoppFehlerVerhalten)||((this.stoppFehlerVerhalten!= null)&&this.stoppFehlerVerhalten.equals(rhs.stoppFehlerVerhalten))))&&((this.aufrufParameter == rhs.aufrufParameter)||((this.aufrufParameter!= null)&&this.aufrufParameter.equals(rhs.aufrufParameter))))&&((this.stoppBedingung == rhs.stoppBedingung)||((this.stoppBedingung!= null)&&this.stoppBedingung.equals(rhs.stoppBedingung))))&&((this.startFehlerVerhalten == rhs.startFehlerVerhalten)||((this.startFehlerVerhalten!= null)&&this.startFehlerVerhalten.equals(rhs.startFehlerVerhalten))))&&((this.initialize == rhs.initialize)||((this.initialize!= null)&&this.initialize.equals(rhs.initialize))))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))))&&((this.startArt == rhs.startArt)||((this.startArt!= null)&&this.startArt.equals(rhs.startArt))))&&((this.mitInkarnationsName == rhs.mitInkarnationsName)||((this.mitInkarnationsName!= null)&&this.mitInkarnationsName.equals(rhs.mitInkarnationsName))));
    }

    public enum InkarnationsTyp {

        DAV("dav"),
        WRAPPED("wrapped"),
        EXTERN("extern");
        private final String value;
        private final static Map<String, Inkarnation.InkarnationsTyp> CONSTANTS = new HashMap<String, Inkarnation.InkarnationsTyp>();

        static {
            for (Inkarnation.InkarnationsTyp c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private InkarnationsTyp(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static Inkarnation.InkarnationsTyp fromValue(String value) {
            Inkarnation.InkarnationsTyp constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
